<template>
  <v-stepper v-model="step" flat vertical >
    <v-stepper-step
      :complete="step > 1"
      step="1"
      editable
    >
      <div v-if="!project || step == 1">Select a project</div>
      <v-list-item v-else class="pa-0">
        <v-list-item-avatar size="40">
          <img v-if="project.avatar_url != null" :src="project.avatar_url">
          </v-list-item-avatar>
          <v-list-item-content>
              <v-list-item-title v-html="project.name_with_namespace"></v-list-item-title>
          </v-list-item-content>
      </v-list-item>
    </v-stepper-step>

    <v-stepper-content step="1">
        <v-container>
            <v-row>
                <v-col class="pt-0 pb-0" cols="12">
                    <ProjectSelector></ProjectSelector>
                </v-col>
                <v-col class="pt-0 pb-0" cols="12">
                    <ScopeSelector></ScopeSelector>
                </v-col>
            </v-row>
            <v-row>
                <v-spacer></v-spacer>
                <v-col align="right">
                    <v-btn color="primary"  v-if='validScope' :href="linkToScope()" text target="_blank">Link to Scope</v-btn>&nbsp;
                    <v-btn color="primary"  @click="step = 2" :disabled='!validScope'>Next</v-btn>
                </v-col>
            </v-row>
        </v-container>
    </v-stepper-content>

    <v-stepper-step
      :complete="step > 2"
      step="2"
    >
      Configure Variables
    </v-stepper-step>

    <v-stepper-content step="2">
      <v-container>
        <v-row>
          <v-col class="pt-0 pb-0" cols="12">
            <VariableForm></VariableForm>
          </v-col>
        </v-row>
        <v-row>
            <v-spacer></v-spacer>
            <v-col cols="8" align="right">
                <v-btn @click="back()" color="secondary">Back</v-btn>
                &nbsp;
                <v-btn v-if="!createdPipeline || !createdPipeline.web_url" color="primary"  @click="createPipeline()" :disabled="!scope || createdPipeline.web_url || !validForm" :loading="creatingPipeline">
                    Create Pipeline
                </v-btn>
                  <v-btn v-else :href="createdPipeline.web_url" target="_blank" color="primary">Go to Pipeline</v-btn>
            </v-col>
        </v-row>
      </v-container>
    </v-stepper-content>
  </v-stepper>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import ProjectSelector from '@/components/ProjectSelector.vue'
import ScopeSelector from '@/components/ScopeSelector.vue'
import VariableForm from '@/components/VariableForm.vue'
import { Action, State } from 'vuex-class'
import * as GitLabHelper from '../gitlab'

@Component({
  components: { ProjectSelector, ScopeSelector, VariableForm }
})
export default class PipelineForm extends Vue {
    step = 1
    creatingPipeline = false
    @State validForm: any
    createdPipeline:Record<string, unknown> = {}
    @State project!: Record<string, string>
    @State scope!: Record<string, string>
    @State scopeType!: string
    @State variables!: Record<string, string>
    @State token!: string
    @Action resetState: any
    @Action setProject: any
    @Action setScope: any

    created (): void {
      const projectID = this.$route.query.project as string
      const branch = this.$route.query.branch as string
      const tag = this.$route.query.tag as string

      if (projectID) {
        const api = GitLabHelper.getAPI()
        api.Projects.show(projectID).then((result) => {
          if (result && !Array.isArray(result)) {
            const project = result as Record<string, string>
            this.setProject(project)
            if (branch) {
              api.Branches.show(project.id, branch).then((result) => {
                if (result && !Array.isArray(result)) {
                  this.setScope({ scope: result, scopeType: 'branches' })
                  this.step = 2
                }
              })
            } else if (tag) {
              api.Tags.show(project.id, tag).then((result) => {
                if (result && !Array.isArray(result)) {
                  this.setScope({ scope: tag, scopeType: 'tags' })
                  this.step = 2
                }
              })
            } else {
              this.step = 2
            }
          }
        })
      }
    }

    linkToScope (): string {
      let url = window.location.href.split('?')[0] + '?project=' + this.project.id
      if (this.scopeType === 'branches') {
        url = url + '&branch=' + this.scope.name
      } else {
        url = url + '&tag=' + this.scope.name
      }

      return url
    }

    resetForm (): void {
      this.step = 1
      this.createdPipeline = {}
      this.resetState()
    }

    back (): void {
      this.createdPipeline = {}
      this.step--
    }

    get validScope (): boolean {
      return !!this.project?.name && !!this.scope?.name
    }

    createPipeline (): void {
      this.creatingPipeline = true
      GitLabHelper.getAPI().Pipelines.create(this.project.id, this.scope.name, { variables: Object.values(this.variables) }).then((pipeline) => {
        this.creatingPipeline = false
        this.createdPipeline = pipeline
      })
    }
}

</script>
